# BotsApi

All URIs are relative to *http://your-mattermost-url.com/api/v4*

Method | HTTP request | Description
------------- | ------------- | -------------
[**assign_bot**](BotsApi.md#assign_bot) | **POST** /bots/{bot_user_id}/assign/{user_id} | Assign a bot to a user
[**convert_bot_to_user**](BotsApi.md#convert_bot_to_user) | **POST** /bots/{bot_user_id}/convert_to_user | Convert a bot into a user
[**convert_user_to_bot**](BotsApi.md#convert_user_to_bot) | **POST** /users/{user_id}/convert_to_bot | Convert a user into a bot
[**create_bot**](BotsApi.md#create_bot) | **POST** /bots | Create a bot
[**delete_bot_icon_image**](BotsApi.md#delete_bot_icon_image) | **DELETE** /bots/{bot_user_id}/icon | Delete bot&#39;s LHS icon image
[**disable_bot**](BotsApi.md#disable_bot) | **POST** /bots/{bot_user_id}/disable | Disable a bot
[**enable_bot**](BotsApi.md#enable_bot) | **POST** /bots/{bot_user_id}/enable | Enable a bot
[**get_bot**](BotsApi.md#get_bot) | **GET** /bots/{bot_user_id} | Get a bot
[**get_bot_icon_image**](BotsApi.md#get_bot_icon_image) | **GET** /bots/{bot_user_id}/icon | Get bot&#39;s LHS icon
[**get_bots**](BotsApi.md#get_bots) | **GET** /bots | Get bots
[**patch_bot**](BotsApi.md#patch_bot) | **PUT** /bots/{bot_user_id} | Patch a bot
[**set_bot_icon_image**](BotsApi.md#set_bot_icon_image) | **POST** /bots/{bot_user_id}/icon | Set bot&#39;s LHS icon image


# **assign_bot**
> assign_bot(_api::BotsApi, bot_user_id::String, user_id::String; _mediaType=nothing) -> Bot, OpenAPI.Clients.ApiResponse <br/>
> assign_bot(_api::BotsApi, response_stream::Channel, bot_user_id::String, user_id::String; _mediaType=nothing) -> Channel{ Bot }, OpenAPI.Clients.ApiResponse

Assign a bot to a user

Assign a bot to a specified user. ##### Permissions Must have `manage_bots` permission.  __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]
**user_id** | **String**| The user ID to assign the bot to. | [default to nothing]

### Return type

[**Bot**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **convert_bot_to_user**
> convert_bot_to_user(_api::BotsApi, bot_user_id::String, convert_bot_to_user_request::ConvertBotToUserRequest; set_system_admin=nothing, _mediaType=nothing) -> StatusOK, OpenAPI.Clients.ApiResponse <br/>
> convert_bot_to_user(_api::BotsApi, response_stream::Channel, bot_user_id::String, convert_bot_to_user_request::ConvertBotToUserRequest; set_system_admin=nothing, _mediaType=nothing) -> Channel{ StatusOK }, OpenAPI.Clients.ApiResponse

Convert a bot into a user

Convert a bot into a user.  __Minimum server version__: 5.26  ##### Permissions Must have `manage_system` permission. 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]
**convert_bot_to_user_request** | [**ConvertBotToUserRequest**](ConvertBotToUserRequest.md)| Data to be used in the user creation | 

### Optional Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **set_system_admin** | **Bool**| Whether to give the user the system admin role. | [default to false]

### Return type

[**StatusOK**](StatusOK.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **convert_user_to_bot**
> convert_user_to_bot(_api::BotsApi, user_id::String; _mediaType=nothing) -> StatusOK, OpenAPI.Clients.ApiResponse <br/>
> convert_user_to_bot(_api::BotsApi, response_stream::Channel, user_id::String; _mediaType=nothing) -> Channel{ StatusOK }, OpenAPI.Clients.ApiResponse

Convert a user into a bot

Convert a user into a bot.  __Minimum server version__: 5.26  ##### Permissions Must have `manage_system` permission. 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**user_id** | **String**| User GUID | [default to nothing]

### Return type

[**StatusOK**](StatusOK.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **create_bot**
> create_bot(_api::BotsApi, create_bot_request::CreateBotRequest; _mediaType=nothing) -> Bot, OpenAPI.Clients.ApiResponse <br/>
> create_bot(_api::BotsApi, response_stream::Channel, create_bot_request::CreateBotRequest; _mediaType=nothing) -> Channel{ Bot }, OpenAPI.Clients.ApiResponse

Create a bot

Create a new bot account on the system. Username is required. ##### Permissions Must have `create_bot` permission. __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**create_bot_request** | [**CreateBotRequest**](CreateBotRequest.md)| Bot to be created | 

### Return type

[**Bot**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **delete_bot_icon_image**
> delete_bot_icon_image(_api::BotsApi, bot_user_id::String; _mediaType=nothing) -> StatusOK, OpenAPI.Clients.ApiResponse <br/>
> delete_bot_icon_image(_api::BotsApi, response_stream::Channel, bot_user_id::String; _mediaType=nothing) -> Channel{ StatusOK }, OpenAPI.Clients.ApiResponse

Delete bot's LHS icon image

Delete bot's LHS icon image based on bot_user_id string parameter. ##### Permissions Must have `manage_bots` permission. __Minimum server version__: 5.14 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]

### Return type

[**StatusOK**](StatusOK.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **disable_bot**
> disable_bot(_api::BotsApi, bot_user_id::String; _mediaType=nothing) -> Bot, OpenAPI.Clients.ApiResponse <br/>
> disable_bot(_api::BotsApi, response_stream::Channel, bot_user_id::String; _mediaType=nothing) -> Channel{ Bot }, OpenAPI.Clients.ApiResponse

Disable a bot

Disable a bot. ##### Permissions Must have `manage_bots` permission.  __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]

### Return type

[**Bot**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **enable_bot**
> enable_bot(_api::BotsApi, bot_user_id::String; _mediaType=nothing) -> Bot, OpenAPI.Clients.ApiResponse <br/>
> enable_bot(_api::BotsApi, response_stream::Channel, bot_user_id::String; _mediaType=nothing) -> Channel{ Bot }, OpenAPI.Clients.ApiResponse

Enable a bot

Enable a bot. ##### Permissions Must have `manage_bots` permission.  __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]

### Return type

[**Bot**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **get_bot**
> get_bot(_api::BotsApi, bot_user_id::String; include_deleted=nothing, _mediaType=nothing) -> Bot, OpenAPI.Clients.ApiResponse <br/>
> get_bot(_api::BotsApi, response_stream::Channel, bot_user_id::String; include_deleted=nothing, _mediaType=nothing) -> Channel{ Bot }, OpenAPI.Clients.ApiResponse

Get a bot

Get a bot specified by its bot id. ##### Permissions Must have `read_bots` permission for bots you are managing, and `read_others_bots` permission for bots others are managing. __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]

### Optional Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **include_deleted** | **Bool**| If deleted bots should be returned. | [default to nothing]

### Return type

[**Bot**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **get_bot_icon_image**
> get_bot_icon_image(_api::BotsApi, bot_user_id::String; _mediaType=nothing) -> Nothing, OpenAPI.Clients.ApiResponse <br/>
> get_bot_icon_image(_api::BotsApi, response_stream::Channel, bot_user_id::String; _mediaType=nothing) -> Channel{ Nothing }, OpenAPI.Clients.ApiResponse

Get bot's LHS icon

Get a bot's LHS icon image based on bot_user_id string parameter. ##### Permissions Must be logged in. __Minimum server version__: 5.14 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]

### Return type

Nothing

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **get_bots**
> get_bots(_api::BotsApi; page=nothing, per_page=nothing, include_deleted=nothing, only_orphaned=nothing, _mediaType=nothing) -> Vector{Bot}, OpenAPI.Clients.ApiResponse <br/>
> get_bots(_api::BotsApi, response_stream::Channel; page=nothing, per_page=nothing, include_deleted=nothing, only_orphaned=nothing, _mediaType=nothing) -> Channel{ Vector{Bot} }, OpenAPI.Clients.ApiResponse

Get bots

Get a page of a list of bots. ##### Permissions Must have `read_bots` permission for bots you are managing, and `read_others_bots` permission for bots others are managing. __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 

### Optional Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **page** | **Int64**| The page to select. | [default to 0]
 **per_page** | **Int64**| The number of users per page. There is a maximum limit of 200 users per page. | [default to 60]
 **include_deleted** | **Bool**| If deleted bots should be returned. | [default to nothing]
 **only_orphaned** | **Bool**| When true, only orphaned bots will be returned. A bot is consitered orphaned if it&#39;s owner has been deactivated. | [default to nothing]

### Return type

[**Vector{Bot}**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **patch_bot**
> patch_bot(_api::BotsApi, bot_user_id::String, create_bot_request::CreateBotRequest; _mediaType=nothing) -> Bot, OpenAPI.Clients.ApiResponse <br/>
> patch_bot(_api::BotsApi, response_stream::Channel, bot_user_id::String, create_bot_request::CreateBotRequest; _mediaType=nothing) -> Channel{ Bot }, OpenAPI.Clients.ApiResponse

Patch a bot

Partially update a bot by providing only the fields you want to update. Omitted fields will not be updated. The fields that can be updated are defined in the request body, all other provided fields will be ignored. ##### Permissions Must have `manage_bots` permission.  __Minimum server version__: 5.10 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]
**create_bot_request** | [**CreateBotRequest**](CreateBotRequest.md)| Bot to be created | 

### Return type

[**Bot**](Bot.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

# **set_bot_icon_image**
> set_bot_icon_image(_api::BotsApi, bot_user_id::String, image::String; _mediaType=nothing) -> StatusOK, OpenAPI.Clients.ApiResponse <br/>
> set_bot_icon_image(_api::BotsApi, response_stream::Channel, bot_user_id::String, image::String; _mediaType=nothing) -> Channel{ StatusOK }, OpenAPI.Clients.ApiResponse

Set bot's LHS icon image

Set a bot's LHS icon image based on bot_user_id string parameter. Icon image must be SVG format, all other formats are rejected. ##### Permissions Must have `manage_bots` permission. __Minimum server version__: 5.14 

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_api** | **BotsApi** | API context | 
**bot_user_id** | **String**| Bot user ID | [default to nothing]
**image** | **String****String**| SVG icon image to be uploaded | [default to nothing]

### Return type

[**StatusOK**](StatusOK.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#api-endpoints) [[Back to Model list]](../README.md#models) [[Back to README]](../README.md)

