# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct BleveApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `BleveApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ BleveApi }) = "http://your-mattermost-url.com/api/v4"

const _returntypes_purge_bleve_indexes_BleveApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => StatusOK,
    Regex("^" * replace("500", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("501", "x"=>".") * "\$") => AppError,
)

function _oacinternal_purge_bleve_indexes(_api::BleveApi; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_purge_bleve_indexes_BleveApi, "/bleve/purge_indexes", ["bearerAuth", ])
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Purge all Bleve indexes

Deletes all Bleve indexes and their contents. After calling this endpoint, it is necessary to schedule a new Bleve indexing job to repopulate the indexes. __Minimum server version__: 5.24 ##### Permissions Must have `sysconsole_write_experimental` permission. 

Params:

Return: StatusOK, OpenAPI.Clients.ApiResponse
"""
function purge_bleve_indexes(_api::BleveApi; _mediaType=nothing)
    _ctx = _oacinternal_purge_bleve_indexes(_api; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function purge_bleve_indexes(_api::BleveApi, response_stream::Channel; _mediaType=nothing)
    _ctx = _oacinternal_purge_bleve_indexes(_api; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export purge_bleve_indexes
