# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct MigrateApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `MigrateApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ MigrateApi }) = "http://your-mattermost-url.com/api/v4"

const _returntypes_migrate_auth_to_ldap_MigrateApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("400", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("401", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("403", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("501", "x"=>".") * "\$") => AppError,
)

function _oacinternal_migrate_auth_to_ldap(_api::MigrateApi; migrate_auth_to_ldap_request=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_migrate_auth_to_ldap_MigrateApi, "/users/migrate_auth/ldap", ["bearerAuth", ], migrate_auth_to_ldap_request)
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Migrate user accounts authentication type to LDAP.

Migrates accounts from one authentication provider to another. For example, you can upgrade your authentication provider from email to LDAP. __Minimum server version__: 5.28 ##### Permissions Must have `manage_system` permission. 

Params:
- migrate_auth_to_ldap_request::MigrateAuthToLdapRequest

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function migrate_auth_to_ldap(_api::MigrateApi; migrate_auth_to_ldap_request=nothing, _mediaType=nothing)
    _ctx = _oacinternal_migrate_auth_to_ldap(_api; migrate_auth_to_ldap_request=migrate_auth_to_ldap_request, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function migrate_auth_to_ldap(_api::MigrateApi, response_stream::Channel; migrate_auth_to_ldap_request=nothing, _mediaType=nothing)
    _ctx = _oacinternal_migrate_auth_to_ldap(_api; migrate_auth_to_ldap_request=migrate_auth_to_ldap_request, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

const _returntypes_migrate_auth_to_saml_MigrateApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("400", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("401", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("403", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("501", "x"=>".") * "\$") => AppError,
)

function _oacinternal_migrate_auth_to_saml(_api::MigrateApi; migrate_auth_to_saml_request=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_migrate_auth_to_saml_MigrateApi, "/users/migrate_auth/saml", ["bearerAuth", ], migrate_auth_to_saml_request)
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["application/json", ] : [_mediaType])
    return _ctx
end

@doc raw"""Migrate user accounts authentication type to SAML.

Migrates accounts from one authentication provider to another. For example, you can upgrade your authentication provider from email to SAML. __Minimum server version__: 5.28 ##### Permissions Must have `manage_system` permission. 

Params:
- migrate_auth_to_saml_request::MigrateAuthToSamlRequest

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function migrate_auth_to_saml(_api::MigrateApi; migrate_auth_to_saml_request=nothing, _mediaType=nothing)
    _ctx = _oacinternal_migrate_auth_to_saml(_api; migrate_auth_to_saml_request=migrate_auth_to_saml_request, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function migrate_auth_to_saml(_api::MigrateApi, response_stream::Channel; migrate_auth_to_saml_request=nothing, _mediaType=nothing)
    _ctx = _oacinternal_migrate_auth_to_saml(_api; migrate_auth_to_saml_request=migrate_auth_to_saml_request, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export migrate_auth_to_ldap
export migrate_auth_to_saml
