# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct SearchApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `SearchApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ SearchApi }) = "http://your-mattermost-url.com/api/v4"

const _returntypes_search_files_SearchApi = Dict{Regex,Type}(
    Regex("^" * replace("200", "x"=>".") * "\$") => FileInfoList,
    Regex("^" * replace("400", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("401", "x"=>".") * "\$") => AppError,
    Regex("^" * replace("403", "x"=>".") * "\$") => AppError,
)

function _oacinternal_search_files(_api::SearchApi, team_id::String, terms::String, is_or_search::Bool; time_zone_offset=nothing, include_deleted_channels=nothing, page=nothing, per_page=nothing, _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "POST", _returntypes_search_files_SearchApi, "/teams/{team_id}/files/search", ["bearerAuth", ])
    OpenAPI.Clients.set_param(_ctx.path, "team_id", team_id)  # type String
    OpenAPI.Clients.set_param(_ctx.form, "terms", terms)  # type String
    OpenAPI.Clients.set_param(_ctx.form, "is_or_search", is_or_search)  # type Bool
    OpenAPI.Clients.set_param(_ctx.form, "time_zone_offset", time_zone_offset)  # type Int64
    OpenAPI.Clients.set_param(_ctx.form, "include_deleted_channels", include_deleted_channels)  # type Bool
    OpenAPI.Clients.set_param(_ctx.form, "page", page)  # type Int64
    OpenAPI.Clients.set_param(_ctx.form, "per_page", per_page)  # type Int64
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? ["multipart/form-data", ] : [_mediaType])
    return _ctx
end

@doc raw"""Search files in a team

Search for files in a team based on file name, extention and file content (if file content extraction is enabled and supported for the files). __Minimum server version__: 5.34 ##### Permissions Must be authenticated and have the `view_team` permission. 

Params:
- team_id::String (required)
- terms::String (required)
- is_or_search::Bool (required)
- time_zone_offset::Int64
- include_deleted_channels::Bool
- page::Int64
- per_page::Int64

Return: FileInfoList, OpenAPI.Clients.ApiResponse
"""
function search_files(_api::SearchApi, team_id::String, terms::String, is_or_search::Bool; time_zone_offset=nothing, include_deleted_channels=nothing, page=nothing, per_page=nothing, _mediaType=nothing)
    _ctx = _oacinternal_search_files(_api, team_id, terms, is_or_search; time_zone_offset=time_zone_offset, include_deleted_channels=include_deleted_channels, page=page, per_page=per_page, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function search_files(_api::SearchApi, response_stream::Channel, team_id::String, terms::String, is_or_search::Bool; time_zone_offset=nothing, include_deleted_channels=nothing, page=nothing, per_page=nothing, _mediaType=nothing)
    _ctx = _oacinternal_search_files(_api, team_id, terms, is_or_search; time_zone_offset=time_zone_offset, include_deleted_channels=include_deleted_channels, page=page, per_page=per_page, _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export search_files
