# This file was generated by the Julia OpenAPI Code Generator
# Do not modify this file directly. Modify the OpenAPI specification instead.

struct TimelineApi <: OpenAPI.APIClientImpl
    client::OpenAPI.Clients.Client
end

"""
The default API base path for APIs in `TimelineApi`.
This can be used to construct the `OpenAPI.Clients.Client` instance.
"""
basepath(::Type{ TimelineApi }) = "http://your-mattermost-url.com/api/v4"

const _returntypes_remove_timeline_event_TimelineApi = Dict{Regex,Type}(
    Regex("^" * replace("204", "x"=>".") * "\$") => Nothing,
    Regex("^" * replace("400", "x"=>".") * "\$") => Error,
    Regex("^" * replace("500", "x"=>".") * "\$") => Error,
)

function _oacinternal_remove_timeline_event(_api::TimelineApi, id::String, event_id::String; _mediaType=nothing)
    _ctx = OpenAPI.Clients.Ctx(_api.client, "DELETE", _returntypes_remove_timeline_event_TimelineApi, "/runs/{id}/timeline/{event-id}/", ["BearerAuth", ])
    OpenAPI.Clients.set_param(_ctx.path, "id", id)  # type String
    OpenAPI.Clients.set_param(_ctx.path, "event-id", event_id)  # type String
    OpenAPI.Clients.set_header_accept(_ctx, ["application/json", ])
    OpenAPI.Clients.set_header_content_type(_ctx, (_mediaType === nothing) ? [] : [_mediaType])
    return _ctx
end

@doc raw"""Remove a timeline event from the playbook run

Params:
- id::String (required)
- event_id::String (required)

Return: Nothing, OpenAPI.Clients.ApiResponse
"""
function remove_timeline_event(_api::TimelineApi, id::String, event_id::String; _mediaType=nothing)
    _ctx = _oacinternal_remove_timeline_event(_api, id, event_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx)
end

function remove_timeline_event(_api::TimelineApi, response_stream::Channel, id::String, event_id::String; _mediaType=nothing)
    _ctx = _oacinternal_remove_timeline_event(_api, id, event_id; _mediaType=_mediaType)
    return OpenAPI.Clients.exec(_ctx, response_stream)
end

export remove_timeline_event
